// wxmaze.cpp

#include <wx/wx.h>

enum {
	 ID_QUIT  = wxID_EXIT
	,ID_ABOUT = wxID_ABOUT
};

class MazeCanvas // TODO: public wxCanvas
{
	public:
		// TODO
};

class Frame : public wxFrame
{
	private:
		MazeCanvas * canvas;
	public:
		Frame(const wxString &, const wxPoint &, const wxSize &);
		void on_quit(wxCommandEvent &);
		void on_about(wxCommandEvent &);

	DECLARE_EVENT_TABLE()
};

BEGIN_EVENT_TABLE(Frame, wxFrame)
	EVT_MENU(ID_QUIT,  Frame::on_quit)
	EVT_MENU(ID_ABOUT, Frame::on_about)
END_EVENT_TABLE()

Frame::Frame(const wxString & title, const wxPoint & pos, const wxSize & size)
	: wxFrame(NULL, -1, title, pos, size)
	, canvas(0)
{
	// menu
	wxMenu * menu_file = new wxMenu;
	menu_file->Append(ID_QUIT, wxT("&Quit"));
	wxMenu * menu_help= new wxMenu;
	menu_help->Append(ID_ABOUT, wxT("&About"));
	wxMenuBar * menubar = new wxMenuBar;
	menubar->Append(menu_file, wxT("&File"));
	menubar->Append(menu_help, wxT("&Help"));
	SetMenuBar(menubar);

	// TODO: canvas
}

void Frame::on_quit(wxCommandEvent &)
{
	Close(true);
}

void Frame::on_about(wxCommandEvent &)
{
	wxMessageBox(
		wxString::Format(wxT("Labyrinth\n\nBuild: %s %s\n\n"), wxT(__DATE__), wxT(__TIME__)),
		wxT("About"), wxOK | wxICON_INFORMATION, this);
}


class App : public wxApp
{
	public:
		virtual bool OnInit();
};

IMPLEMENT_APP(App)

bool App::OnInit()
{
	wxFrame * frame = new Frame(wxT("Labyrinth"), wxDefaultPosition, wxSize(600, 600));
	frame->Show(true);
	SetTopWindow(frame);
	return true;
}

